(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2013-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: black_box_spec.mli,v 1.23 2014-03-07 23:53:28 fclement Exp $ *)

(** {3 Interface to the external part of State maker functor} *)

open Scalar_spec;;
open Components_spec;;

module type MAKER =
  functor (Scal : SCALAR) ->
  functor (Comps : COMPONENTS) ->
sig
  module Stt : module type of (State_types.Make (Scal) (Comps));;
  
  type scalar = Scal.t;;
  type 'a components = 'a Comps.t;;
  
  type gradients = Stt.gradients;;
  type partitions = Stt.partitions;;
  type state = Stt.state;;
  type selected_cutting = Stt.selected_cutting;;
  
  val init : unit -> state;;
  val final : state -> unit;;
  
  val grad : state -> gradients;;
  val optim : state -> partitions -> selected_cutting;;
end
;;
