(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2013-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: state_types.ml,v 1.11 2014-02-06 23:05:07 fclement Exp $ *)

open Refinement_types;;
open Scalar_spec;;
open Components_spec;;

module Make =
  functor (Scal : SCALAR) ->
  functor (Comps : COMPONENTS) ->
struct
  type scalar = Scal.t;;
  type 'a components = 'a Comps.t;;
  
  type parameters = scalar parameter components;;
  type gradients = scalar gradient components;;
  type partitions = scalar partition components;;
  type zonations = scalar zonation components;;
  
  type cost = scalar exact_indicator;;
  
  type state = zonations * cost;;
  type selected_cutting = state;;
end
;;
